#pragma once

//game client listener
namespace a8
{
    class TcpListener;
}

#pragma pack(1)

struct ServerPktHeader
{
    unsigned short size;
    unsigned short cmd;
};

struct ClientPktHeader
{
    unsigned short size;
    unsigned int cmd;
};

#pragma pack()

class GCListener : public a8::Singleton<GCListener>
{
 private:
    GCListener() {};
    friend class a8::Singleton<GCListener>;

 public:
    void Init();
    void UnInit();

    template <typename T>
    void SendMsg(int socket_handle, T& msg)
    {
        static int msgid = f8::Net_GetMessageId(msg);

        InternalSendMsg(socket_handle, msgid, msg);
    }

    void SendText(int sockhandle, const std::string& text);

    void ForceCloseClient(int sockhandle);
    void MarkClient(int sockhandle, bool is_active);
    void SetKey(int sockhandle, const std::string& key);

 private:
    void InternalSendMsg(int socket_handle, int msgid, google::protobuf::Message& msg);

 private:
    a8::TcpListener *tcp_listener_ = nullptr;
};
