#pragma once

enum SocketFrom_e
{
    SF_GameClient,
};

enum InnerMesssage_e
{
    IM_ClientSocketDisconnect  = 100,
    IM_ExecGM,
    IM_HttpResponse,
};

//网络处理对象
enum NetHandler_e
{
    HID_PlayerMgr,
    HID_Plyaer
};

enum ResponseCodes
{
    RESPONSE_SUCCESS                                       = 0x00,
    RESPONSE_FAILURE                                       = 0x01,
    RESPONSE_CANCELLED                                     = 0x02,
    RESPONSE_DISCONNECTED                                  = 0x03,
    RESPONSE_FAILED_TO_CONNECT                             = 0x04,
    RESPONSE_CONNECTED                                     = 0x05,
    RESPONSE_VERSION_MISMATCH                              = 0x06,

    CSTATUS_CONNECTING                                     = 0x07,
    CSTATUS_NEGOTIATING_SECURITY                           = 0x08,
    CSTATUS_NEGOTIATION_COMPLETE                           = 0x09,
    CSTATUS_NEGOTIATION_FAILED                             = 0x0A,
    CSTATUS_AUTHENTICATING                                 = 0x0B,

    AUTH_OK                                                = 0x0C,
    AUTH_FAILED                                            = 0x0D,
    AUTH_REJECT                                            = 0x0E,
    AUTH_BAD_SERVER_PROOF                                  = 0x0F,
    AUTH_UNAVAILABLE                                       = 0x10,
    AUTH_SYSTEM_ERROR                                      = 0x11,
    AUTH_BILLING_ERROR                                     = 0x12,
    AUTH_BILLING_EXPIRED                                   = 0x13,
    AUTH_VERSION_MISMATCH                                  = 0x14,
    AUTH_UNKNOWN_ACCOUNT                                   = 0x15,
    AUTH_INCORRECT_PASSWORD                                = 0x16,
    AUTH_SESSION_EXPIRED                                   = 0x17,
    AUTH_SERVER_SHUTTING_DOWN                              = 0x18,
    AUTH_ALREADY_LOGGING_IN                                = 0x19,
    AUTH_LOGIN_SERVER_NOT_FOUND                            = 0x1A,
    AUTH_WAIT_QUEUE                                        = 0x1B,
    AUTH_BANNED                                            = 0x1C,
    AUTH_ALREADY_ONLINE                                    = 0x1D,
    AUTH_NO_TIME                                           = 0x1E,
    AUTH_DB_BUSY                                           = 0x1F,
    AUTH_SUSPENDED                                         = 0x20,
    AUTH_PARENTAL_CONTROL                                  = 0x21,

    REALM_LIST_IN_PROGRESS                                 = 0x22,
    REALM_LIST_SUCCESS                                     = 0x23,
    REALM_LIST_FAILED                                      = 0x24,
    REALM_LIST_INVALID                                     = 0x25,
    REALM_LIST_REALM_NOT_FOUND                             = 0x26,

    ACCOUNT_CREATE_IN_PROGRESS                             = 0x27,
    ACCOUNT_CREATE_SUCCESS                                 = 0x28,
    ACCOUNT_CREATE_FAILED                                  = 0x29,

    CHAR_LIST_RETRIEVING                                   = 0x2A,
    CHAR_LIST_RETRIEVED                                    = 0x2B,
    CHAR_LIST_FAILED                                       = 0x2C,

    CHAR_CREATE_IN_PROGRESS                                = 0x2D,
    CHAR_CREATE_SUCCESS                                    = 0x2E,
    CHAR_CREATE_ERROR                                      = 0x2F,
    CHAR_CREATE_FAILED                                     = 0x30,
    CHAR_CREATE_NAME_IN_USE                                = 0x31,
    CHAR_CREATE_DISABLED                                   = 0x32,
    CHAR_CREATE_PVP_TEAMS_VIOLATION                        = 0x33,
    CHAR_CREATE_SERVER_LIMIT                               = 0x34,
    CHAR_CREATE_ACCOUNT_LIMIT                              = 0x35,
    CHAR_CREATE_SERVER_QUEUE                               = 0x36,
    CHAR_CREATE_ONLY_EXISTING                              = 0x37,

    CHAR_DELETE_IN_PROGRESS                                = 0x38,
    CHAR_DELETE_SUCCESS                                    = 0x39,
    CHAR_DELETE_FAILED                                     = 0x3A,
    CHAR_DELETE_FAILED_LOCKED_FOR_TRANSFER                 = 0x3B,

    CHAR_LOGIN_IN_PROGRESS                                 = 0x3C,
    CHAR_LOGIN_SUCCESS                                     = 0x3D,
    CHAR_LOGIN_NO_WORLD                                    = 0x3E,
    CHAR_LOGIN_DUPLICATE_CHARACTER                         = 0x3F,
    CHAR_LOGIN_NO_INSTANCES                                = 0x40,
    CHAR_LOGIN_FAILED                                      = 0x41,
    CHAR_LOGIN_DISABLED                                    = 0x42,
    CHAR_LOGIN_NO_CHARACTER                                = 0x43,
    CHAR_LOGIN_LOCKED_FOR_TRANSFER                         = 0x44,

    CHAR_NAME_NO_NAME                                      = 0x45,
    CHAR_NAME_TOO_SHORT                                    = 0x46,
    CHAR_NAME_TOO_LONG                                     = 0x47,
    CHAR_NAME_INVALID_CHARACTER                            = 0x48,
    CHAR_NAME_MIXED_LANGUAGES                              = 0x49,
    CHAR_NAME_PROFANE                                      = 0x4A,
    CHAR_NAME_RESERVED                                     = 0x4B,
    CHAR_NAME_INVALID_APOSTROPHE                           = 0x4C,
    CHAR_NAME_MULTIPLE_APOSTROPHES                         = 0x4D,
    CHAR_NAME_THREE_CONSECUTIVE                            = 0x4E,
    CHAR_NAME_INVALID_SPACE                                = 0x4F,
    CHAR_NAME_CONSECUTIVE_SPACES                           = 0x50,
    CHAR_NAME_FAILURE                                      = 0x51,
    CHAR_NAME_SUCCESS                                      = 0x52,
};

enum PlayerFlags
{
    PLAYER_FLAGS_NONE                   = 0x00000000,
    PLAYER_FLAGS_GROUP_LEADER           = 0x00000001,
    PLAYER_FLAGS_AFK                    = 0x00000002,
    PLAYER_FLAGS_DND                    = 0x00000004,
    PLAYER_FLAGS_GM                     = 0x00000008,
    PLAYER_FLAGS_GHOST                  = 0x00000010,
    PLAYER_FLAGS_RESTING                = 0x00000020,
    PLAYER_FLAGS_UNK7                   = 0x00000040,       // admin?
    PLAYER_FLAGS_FFA_PVP                = 0x00000080,
    PLAYER_FLAGS_CONTESTED_PVP          = 0x00000100,       // Player has been involved in a PvP combat and will be attacked by contested guards
    PLAYER_FLAGS_IN_PVP                 = 0x00000200,
    PLAYER_FLAGS_HIDE_HELM              = 0x00000400,
    PLAYER_FLAGS_HIDE_CLOAK             = 0x00000800,
    PLAYER_FLAGS_PARTIAL_PLAY_TIME      = 0x00001000,       // played long time
    PLAYER_FLAGS_NO_PLAY_TIME           = 0x00002000,       // played too long time
    PLAYER_FLAGS_UNK15                  = 0x00004000,
    PLAYER_FLAGS_UNK16                  = 0x00008000,       // strange visual effect (2.0.1), looks like PLAYER_FLAGS_GHOST flag
    PLAYER_FLAGS_SANCTUARY              = 0x00010000,       // player entered sanctuary
    PLAYER_FLAGS_TAXI_BENCHMARK         = 0x00020000,       // taxi benchmark mode (on/off) (2.0.1)
    PLAYER_FLAGS_PVP_TIMER              = 0x00040000,       // 3.0.2, pvp timer active (after you disable pvp manually)
};

#define MAX_PET_STABLES         2

// stored in character_pet.slot
enum PetSaveMode
{
    PET_SAVE_AS_DELETED        = -1,                        // not saved in fact
    PET_SAVE_AS_CURRENT        =  0,                        // in current slot (with player)
    PET_SAVE_FIRST_STABLE_SLOT =  1,
    PET_SAVE_LAST_STABLE_SLOT  =  MAX_PET_STABLES,          // last in DB stable slot index (including), all higher have same meaning as PET_SAVE_NOT_IN_SLOT
    PET_SAVE_NOT_IN_SLOT       =  100,                      // for avoid conflict with stable size grow will use 100
    PET_SAVE_REAGENTS          =  101                       // PET_SAVE_NOT_IN_SLOT with reagents return
};

// 2^n values
enum AtLoginFlags
{
    AT_LOGIN_NONE                 = 0x00,
    AT_LOGIN_RENAME               = 0x01,
    AT_LOGIN_RESET_SPELLS         = 0x02,
    AT_LOGIN_RESET_TALENTS        = 0x04,
    // AT_LOGIN_CUSTOMIZE         = 0x08, -- used in post-3.x
    // AT_LOGIN_RESET_PET_TALENTS = 0x10, -- used in post-3.x
    AT_LOGIN_FIRST                = 0x20,
};

const char* const PROJ_NAME_FMT = "game%d_gameserver";
const char* const PROJ_ROOT_FMT = "/data/logs/%s";
