#pragma once

class DBEngineImp;
class DBEngine : public a8::Singleton<DBEngine>
{
 private:
    DBEngine() {};
    friend class a8::Singleton<DBEngine>;

 public:
    void Init();
    void UnInit();

    int ExecQuery(const char* querystr, std::initializer_list<a8::XValue> args);
    bool ExecScript(const char* scriptstr, std::initializer_list<a8::XValue> args);
    bool Eof();
    void Next();
    a8::XValue GetValue(short idx);
    std::string GetLastError();
    std::string FormatSqlEx(const char* fmt, std::initializer_list<a8::XValue> args);

 private:
    DBEngineImp* imp_ = nullptr;
};
